import { FightRole, ItemEnum, Role } from "../common/InterfaceAddEnum";
import { RoleConf } from "../ui/tower/conf/RoleConf";

class Data {

    private _roles: { [id: string]: Role } = {};
    //上阵英雄
    private _fightRole: FightRole = [0, 0, 0, 0];
    //羁绊
    private _fate: { [id: string]: {} } = {};
    setData(data: { [id: string]: Role }): void {
        let rConf = RoleConf.data;
        if (data) {
            for (const id in data) {
                if (data.hasOwnProperty(id)) {
                    if (rConf[id]) {
                        const role = data[id];
                        role.conf = rConf[id];
                        this._roles[id] = role;
                        role.type = ItemEnum.role;
                        // console.log(`ID: ${id}, Name: ${role.name}, Level: ${role.level}`);
                    }
                }
            }
        }
    }

    getData() {
        return this._roles;
    }

    getRoleDataByID(id: string | number): Role {
        if (typeof id === 'number') {
            id = id.toString();
        }
        return this._roles[id];
    }

    setRoleDataByID(id: string | number, data: Role) {
        if (typeof id === 'number') {
            id = id.toString();
        }
        if (this._roles[id]) {
            this._roles[id] = data;
        }
    }

    //设置出战角色  data {"1":"xxx","2":"xxx","3":"xxx","4":"xxx"}
    set fightRole(data: { [key: string]: string } | FightRole) {
        if (!data) return;
        this._fightRole = [0, 0, 0, 0];
        if (Array.isArray(data)) {
            this._fightRole = data as FightRole;
        } else {
            for (let i = 0; i < this._fightRole.length; i++) {
                this._fightRole[i] = Number(data[(i + 1).toString()] || "0");
            }
        }
    }

    //获取出战角色
   get fightRole() :FightRole{
        // return [101,201,301,401];
        return this._fightRole;

    }

    set fate(data: { [key: string]: {} }) {
        this._fate = data;
    }

    get fate() {
        return this._fate;
    }

}

export let RoleData = new Data;
